package com.macys.exception;

import java.util.List;

import javax.ws.rs.core.Context;
import javax.ws.rs.core.HttpHeaders;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.ext.ExceptionMapper;
import javax.ws.rs.ext.Provider;

import com.macys.exception.v1.ServiceErrorDataV1;

@Provider
public class RestIllegalArgumentExceptionHandler implements ExceptionMapper<IllegalArgumentException> 
{
    @Context
    private HttpHeaders headers;

    @Override
    public Response toResponse(IllegalArgumentException se) 
    {
        MediaType m; 
        
        List<MediaType> accepts = headers.getAcceptableMediaTypes();
        if (accepts!=null && accepts.size() > 0) {
            //just pick the first one
        	m = accepts.get(0);
        }
        else {
            //if not specified, use the entity type
            m = headers.getMediaType(); // set the response type to the entity type.
        }
        
    	ServiceErrorDataV1 serviceErrorDataV1 = new ServiceErrorDataV1(ErrorCodes.PARAMETER, "Parameter",se.getMessage(),null);
    	javax.ws.rs.core.Response.Status status = Status.BAD_REQUEST;
    	
        return Response.status(status).entity(serviceErrorDataV1).type(m).build();  
    }
}