package com.macys.exception;

import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.ext.ExceptionMapper;
import javax.ws.rs.ext.Provider;

import org.apache.commons.lang.exception.ExceptionUtils;
import org.codehaus.jackson.map.JsonMappingException;

import com.macys.exception.v1.ServiceErrorDataV1;

@Provider
public class RestJsonMappingExceptionHandler implements ExceptionMapper<JsonMappingException> 
{
    @Override
    public Response toResponse(JsonMappingException se) 
    {
    	ServiceErrorDataV1 serviceErrorDataV1 = new ServiceErrorDataV1(ErrorCodes.PARAMETER, "Parameter",se.getMessage(),null);
    	javax.ws.rs.core.Response.Status status = Status.BAD_REQUEST;
    	
        return Response.status(status).entity(serviceErrorDataV1).type(MediaType.APPLICATION_JSON).build();  
    }
}