package com.macys.exception;

import javax.xml.bind.annotation.XmlElement;

/*
*************************************************************************
*                                                                       *
* Module name:  ServiceException.java                                   * 
*                                                                       *
*      Author:                                                          * 
*                                                                       *
*************************************************************************
* (C) COPYRIGHT MACY'S Systems and Technology 2013. ALL RIGHTS RESERVED.*
*************************************************************************
*  Date     Init Vers  Comments                                         *
*---------  ---- ----  -------------------------------------------------* 
* 11/14/13  JER  1402  Remove get methods because JBoss returns 2 copies
*                      of data and message.                                 
*************************************************************************
*/

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

@XmlRootElement(name="fault")
@XmlType(name="", propOrder={"message","data"}, namespace="")
public class ServiceException extends Exception implements java.io.Serializable
{
    private static final long serialVersionUID = -9072226918841109999L;
    
    @XmlElement(name = "message", required = true, nillable = true)
    public String message;
    
	@XmlElement(name = "data", required = true, nillable = true)
    public ServiceErrorData data;

    public ServiceException()
    {
    	this.data    = new ServiceErrorData();
    	this.message = null;
    }

    public ServiceException(ServiceErrorData data)
    {
        this.data = data;
        this.message = null;
    }

    public ServiceException(String message)
    {
        this.data = null;
        this.message = message;
    }
    
    @Override
    @XmlTransient
    public String getMessage()
    {
    	return this.message;
    }
}